
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 1.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _measure_cycle=R5
	.DEF _pre_start=R4

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _adc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x50:
	.DB  0xFF,0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  0x04
	.DW  _0x50*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;Project : AUDI AutoLight
;Version : 5
;Date    : 20/12/2012
;Author  : miko
;Company : MKelectronic
;Comments:
;
;
;Chip type           : ATmega8
;Program type        : Application
;Clock frequency     : 1.000000 MHz (internal RC)
;Memory model        : Small
;External RAM size   : 0
;Data Stack size     : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;#define FIRMWARE_VERSION 5
;
;#define ADC_VREF_TYPE 0xC0
;#define CHARGING_VOLTAGE 13000  //mV
;#define MEAS_CYCLE 128          //voltage measure samples
;#define INT0_CYCLE 255          //int0 samples
;
;#define ALARM       PORTD.1     //buzzer
;#define STATUS      PORTD.4     //led
;#define SW_LIGHT1   PORTD.5     //main lights
;#define SW_LIGHT2   PORTD.6     //parking lights
;#define EXT1        PIND.2      //int0 - manual parking switch
;
;
;void alarm(const unsigned char repeat);
;void lights(const unsigned char enable);
;
;// global variables
;bit engine=0;
;bit lights_on=0;
;bit force_off=0;
;unsigned int measured_voltage[MEAS_CYCLE];
;unsigned char measure_cycle=0;
;unsigned char pre_start=255;
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0030     {

	.CSEG
_ext_int0_isr:
	RCALL SUBOPT_0x0
; 0000 0031     unsigned char valid_int0=INT0_CYCLE;
; 0000 0032 
; 0000 0033     //1'st ext0 = switch on parking lights manually.
; 0000 0034     //Change interrupt sense (falling edge -> rising edge)
; 0000 0035     if(!(MCUCR&0x03))
	ST   -Y,R17
;	valid_int0 -> R17
	LDI  R17,255
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x3)
	BRNE _0x3
; 0000 0036         {
; 0000 0037         while(--valid_int0)
_0x4:
	SUBI R17,LOW(1)
	CPI  R17,0
	BREQ _0x6
; 0000 0038             {
; 0000 0039             delay_ms(3);
	RCALL SUBOPT_0x2
; 0000 003A             if(EXT1)
	SBIS 0x10,2
	RJMP _0x7
; 0000 003B                 return;
	LD   R17,Y+
	RJMP _0x4F
; 0000 003C             }
_0x7:
	RJMP _0x4
_0x6:
; 0000 003D 
; 0000 003E         //parking lights already switched on => DON'T SWITCH ON LIGHTS
; 0000 003F         if(!lights_on)
	SBRC R2,1
	RJMP _0x8
; 0000 0040             force_off=1;
	SET
	BLD  R2,2
; 0000 0041 
; 0000 0042         MCUCR|=0x03;
_0x8:
	RCALL SUBOPT_0x1
	ORI  R30,LOW(0x3)
	OUT  0x35,R30
; 0000 0043         return;
	LD   R17,Y+
	RJMP _0x4F
; 0000 0044         }
; 0000 0045 
; 0000 0046     //2'nd ext0 = switch off parking lights manually.
; 0000 0047     //disable lights
; 0000 0048     if((MCUCR&0x03)==0x03)
_0x3:
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x3)
	ANDI R31,HIGH(0x3)
	SBIW R30,3
	BRNE _0x9
; 0000 0049         {
; 0000 004A         while(--valid_int0)
_0xA:
	SUBI R17,LOW(1)
	CPI  R17,0
	BREQ _0xC
; 0000 004B             {
; 0000 004C             delay_ms(3);
	RCALL SUBOPT_0x2
; 0000 004D             if(!EXT1)
	SBIC 0x10,2
	RJMP _0xD
; 0000 004E                 return;
	LD   R17,Y+
	RJMP _0x4F
; 0000 004F             }
_0xD:
	RJMP _0xA
_0xC:
; 0000 0050         force_off=1;
	SET
	BLD  R2,2
; 0000 0051         GICR&=0xBF; //disable INT0
	RCALL SUBOPT_0x3
	ANDI R30,LOW(0xBF)
	ANDI R31,HIGH(0xBF)
	OUT  0x3B,R30
; 0000 0052         return;
	LD   R17,Y+
	RJMP _0x4F
; 0000 0053         }
; 0000 0054     }
_0x9:
	LD   R17,Y+
	RJMP _0x4F
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0058     {
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0059     if(--pre_start==0)
	DEC  R4
	BRNE _0xE
; 0000 005A         TCCR0=0;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 005B     }
_0xE:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;// Timer 1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 005F     {
_timer1_ovf_isr:
	ST   -Y,R30
; 0000 0060     TCCR1B=0;
	LDI  R30,LOW(0)
	OUT  0x2E,R30
; 0000 0061     }
	LD   R30,Y+
	RETI
;
;// Timer 2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0065     {
_timer2_ovf_isr:
	RCALL SUBOPT_0x0
; 0000 0066     STATUS=~STATUS;
	SBIS 0x12,4
	RJMP _0xF
	CBI  0x12,4
	RJMP _0x10
_0xF:
	SBI  0x12,4
_0x10:
; 0000 0067     #asm("cli")
	cli
; 0000 0068     delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x4
; 0000 0069     #asm("sei")
	sei
; 0000 006A     }
_0x4F:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// ADC interrupt service routine
;interrupt [ADC_INT] void adc_isr(void)
; 0000 006E     {
_adc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 006F     unsigned int adc_data;
; 0000 0070     unsigned char i;
; 0000 0071     unsigned char voltage_ok=0;
; 0000 0072     unsigned char voltage_ng=0;
; 0000 0073 
; 0000 0074     // Read the AD conversion result
; 0000 0075     adc_data=ADCW;
	RCALL __SAVELOCR6
;	adc_data -> R16,R17
;	i -> R19
;	voltage_ok -> R18
;	voltage_ng -> R21
	LDI  R18,0
	LDI  R21,0
	__INWR 16,17,4
; 0000 0076 
; 0000 0077     //store measured voltage [mV]
; 0000 0078     measured_voltage[measure_cycle]=(int)(adc_data*2.56*6.5); //5.681 - calculated voltage divider
	MOV  R30,R5
	RCALL SUBOPT_0x5
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R30,R16
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x4023D70A
	RCALL __MULF12
	__GETD2N 0x40D00000
	RCALL __MULF12
	RCALL __CFD1
	CLR  R22
	CLR  R23
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
; 0000 0079 
; 0000 007A     //check measured conditions
; 0000 007B     for(i=0;i<MEAS_CYCLE;i++)
	LDI  R19,LOW(0)
_0x12:
	CPI  R19,128
	BRSH _0x13
; 0000 007C         {
; 0000 007D         if(measured_voltage[i]>CHARGING_VOLTAGE)
	MOV  R30,R19
	RCALL SUBOPT_0x5
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	CPI  R30,LOW(0x32C9)
	LDI  R26,HIGH(0x32C9)
	CPC  R31,R26
	BRLO _0x14
; 0000 007E             voltage_ok++;
	SUBI R18,-1
; 0000 007F         else
	RJMP _0x15
_0x14:
; 0000 0080             voltage_ng++;
	SUBI R21,-1
; 0000 0081         }
_0x15:
	SUBI R19,-1
	RJMP _0x12
_0x13:
; 0000 0082 
; 0000 0083     //reset array index
; 0000 0084     if(++measure_cycle==MEAS_CYCLE)
	INC  R5
	LDI  R30,LOW(128)
	CP   R30,R5
	BRNE _0x16
; 0000 0085         measure_cycle=0;
	CLR  R5
; 0000 0086 
; 0000 0087     // check charging voltage condition (all samples must be valid)
; 0000 0088     if(voltage_ok==MEAS_CYCLE)
_0x16:
	CPI  R18,128
	BRNE _0x17
; 0000 0089         {
; 0000 008A         engine=1;
	SET
	BLD  R2,0
; 0000 008B         STATUS=0;   //Status LED
	CBI  0x12,4
; 0000 008C         }
; 0000 008D     if(voltage_ng==MEAS_CYCLE)
_0x17:
	CPI  R21,128
	BRNE _0x1A
; 0000 008E         {
; 0000 008F         engine=0;
	CLT
	BLD  R2,0
; 0000 0090         STATUS=1;
	SBI  0x12,4
; 0000 0091         }
; 0000 0092     }
_0x1A:
	RCALL __LOADLOCR6
	ADIW R28,6
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;void alarm(const unsigned char repeat)
; 0000 0095     {
_alarm:
; 0000 0096     unsigned char i;
; 0000 0097 
; 0000 0098     //ignore alarms less than 1min after start
; 0000 0099     if(pre_start)
	ST   -Y,R17
;	repeat -> Y+1
;	i -> R17
	TST  R4
	BRNE _0x2000001
; 0000 009A         return;
; 0000 009B 
; 0000 009C     for(i=0;i<repeat;i++)
	LDI  R17,LOW(0)
_0x1F:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x20
; 0000 009D         {
; 0000 009E         // Beeper
; 0000 009F         #asm("cli")
	cli
; 0000 00A0         ALARM=1;
	SBI  0x12,1
; 0000 00A1         delay_ms(150);
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	RCALL SUBOPT_0x4
; 0000 00A2         ALARM=0;
	CBI  0x12,1
; 0000 00A3         delay_ms(80);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	RCALL SUBOPT_0x4
; 0000 00A4         #asm("sei")
	sei
; 0000 00A5         }
	SUBI R17,-1
	RJMP _0x1F
_0x20:
; 0000 00A6 
; 0000 00A7     TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
; 0000 00A8     while(TCCR1B);
_0x25:
	IN   R30,0x2E
	CPI  R30,0
	BRNE _0x25
; 0000 00A9     }
_0x2000001:
	LDD  R17,Y+0
	ADIW R28,2
	RET
;
;void lights(const unsigned char enable)
; 0000 00AC     {
_lights:
; 0000 00AD     switch(enable)
;	enable -> Y+0
	LD   R30,Y
	LDI  R31,0
; 0000 00AE         {
; 0000 00AF         //turn off
; 0000 00B0         case 0:
	SBIW R30,0
	BRNE _0x2B
; 0000 00B1         SW_LIGHT1=0;    //disable xenon lights
	CBI  0x12,5
; 0000 00B2         SW_LIGHT2=0;    //disable parking lights
	CBI  0x12,6
; 0000 00B3         TCCR2=0x07;     //blink status led
	LDI  R30,LOW(7)
	OUT  0x25,R30
; 0000 00B4         lights_on=0;
	CLT
	BLD  R2,1
; 0000 00B5         break;
	RJMP _0x2A
; 0000 00B6 
; 0000 00B7         //turn on
; 0000 00B8         case 1:
_0x2B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2A
; 0000 00B9         #asm("cli")
	cli
; 0000 00BA         SW_LIGHT2=1;    //switch on parking lights
	SBI  0x12,6
; 0000 00BB         delay_ms(1000); //delay for sure :)
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x4
; 0000 00BC         SW_LIGHT1=1;    //switch on xenon lights
	SBI  0x12,5
; 0000 00BD         ALARM=1;
	SBI  0x12,1
; 0000 00BE         delay_ms(700);
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	RCALL SUBOPT_0x4
; 0000 00BF         ALARM=0;
	CBI  0x12,1
; 0000 00C0         lights_on=1;
	SET
	BLD  R2,1
; 0000 00C1         #asm("sei")
	sei
; 0000 00C2         break;
; 0000 00C3         }
_0x2A:
; 0000 00C4     }
	ADIW R28,1
	RET
;
;void main(void)
; 0000 00C7 {
_main:
; 0000 00C8 unsigned char j;
; 0000 00C9 
; 0000 00CA // Input/Output Ports initialization
; 0000 00CB // Port B initialization
; 0000 00CC // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00CD // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00CE PORTB=0x00;
;	j -> R17
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 00CF DDRB=0x00;
	OUT  0x17,R30
; 0000 00D0 
; 0000 00D1 // Port C initialization
; 0000 00D2 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00D3 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00D4 PORTC=0x00;
	OUT  0x15,R30
; 0000 00D5 DDRC=0x00;
	OUT  0x14,R30
; 0000 00D6 
; 0000 00D7 // Port D initialization
; 0000 00D8 // Func7=In Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=In
; 0000 00D9 // State7=T State6=0 State5=0 State4=1 State3=T State2=T State1=0 State0=T
; 0000 00DA PORTD=0x10;
	LDI  R30,LOW(16)
	OUT  0x12,R30
; 0000 00DB DDRD=0x72;
	LDI  R30,LOW(114)
	OUT  0x11,R30
; 0000 00DC 
; 0000 00DD // Timer/Counter 0 initialization
; 0000 00DE // Clock source: System Clock
; 0000 00DF // Clock value: 0.977 kHz
; 0000 00E0 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 00E1 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00E2 
; 0000 00E3 // Timer/Counter 1 initialization
; 0000 00E4 // Clock source: System Clock
; 0000 00E5 // Clock value: 15.625 kHz
; 0000 00E6 // Mode: Normal top=FFFFh
; 0000 00E7 // OC1A output: Discon.
; 0000 00E8 // OC1B output: Discon.
; 0000 00E9 // Noise Canceler: Off
; 0000 00EA // Input Capture on Falling Edge
; 0000 00EB // Timer 1 Overflow Interrupt: On
; 0000 00EC // Input Capture Interrupt: Off
; 0000 00ED // Compare A Match Interrupt: Off
; 0000 00EE // Compare B Match Interrupt: Off
; 0000 00EF TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00F0 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00F1 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00F2 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00F3 ICR1H=0x00;
	OUT  0x27,R30
; 0000 00F4 ICR1L=0x00;
	OUT  0x26,R30
; 0000 00F5 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00F6 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00F7 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00F8 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00F9 
; 0000 00FA // Timer/Counter 2 initialization
; 0000 00FB // Clock source: System Clock
; 0000 00FC // Clock value: 0.977 kHz
; 0000 00FD // Mode: Normal top=FFh
; 0000 00FE // OC2 output: Disconnected
; 0000 00FF ASSR=0x00;
	OUT  0x22,R30
; 0000 0100 TCCR2=0x00;
	OUT  0x25,R30
; 0000 0101 TCNT2=0x00;
	OUT  0x24,R30
; 0000 0102 OCR2=0x00;
	OUT  0x23,R30
; 0000 0103 
; 0000 0104 // External Interrupt(s) initialization
; 0000 0105 // INT0: On
; 0000 0106 // INT0 Mode: Low level
; 0000 0107 // INT1: Off
; 0000 0108 GICR|=0x40;
	RCALL SUBOPT_0x3
	ORI  R30,0x40
	OUT  0x3B,R30
; 0000 0109 MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
; 0000 010A GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 010B 
; 0000 010C // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 010D TIMSK=0x45;
	LDI  R30,LOW(69)
	OUT  0x39,R30
; 0000 010E 
; 0000 010F // Analog Comparator initialization
; 0000 0110 // Analog Comparator: Off
; 0000 0111 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0112 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0113 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0114 
; 0000 0115 // ADC initialization
; 0000 0116 // ADC Clock frequency: 7.813 kHz
; 0000 0117 // ADC Voltage Reference: Int., cap. on AREF
; 0000 0118 ADMUX=ADC_VREF_TYPE | 0x04;
	LDI  R30,LOW(196)
	OUT  0x7,R30
; 0000 0119 ADCSRA=0xEF;
	LDI  R30,LOW(239)
	OUT  0x6,R30
; 0000 011A 
; 0000 011B //signalize FW version
; 0000 011C for(j=0;j<FIRMWARE_VERSION;j++)
	LDI  R17,LOW(0)
_0x3A:
	CPI  R17,5
	BRSH _0x3B
; 0000 011D     {
; 0000 011E     STATUS=0;
	CBI  0x12,4
; 0000 011F     delay_ms(80);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	RCALL SUBOPT_0x4
; 0000 0120     STATUS=1;
	SBI  0x12,4
; 0000 0121     delay_ms(150);
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	RCALL SUBOPT_0x4
; 0000 0122     }
	SUBI R17,-1
	RJMP _0x3A
_0x3B:
; 0000 0123 
; 0000 0124 // Global enable interrupts
; 0000 0125 #asm("sei")
	sei
; 0000 0126 
; 0000 0127 while (1)
_0x40:
; 0000 0128     {
; 0000 0129     //MANUAL MODE
; 0000 012A     if(force_off)
	SBRS R2,2
	RJMP _0x43
; 0000 012B         {
; 0000 012C         //manual switch on then off parking lights -> TURN OFF LIGHTS!
; 0000 012D         lights(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _lights
; 0000 012E         }
; 0000 012F 
; 0000 0130     //AUTO MODE
; 0000 0131     else
	RJMP _0x44
_0x43:
; 0000 0132         {
; 0000 0133         //engine is running, ligths aren't lighting yet -> TURN ON LIGHTS!
; 0000 0134         if(engine && !lights_on)
	SBRS R2,0
	RJMP _0x46
	SBRS R2,1
	RJMP _0x47
_0x46:
	RJMP _0x45
_0x47:
; 0000 0135             lights(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lights
; 0000 0136 
; 0000 0137         //low voltage during engine run -> ALARM!
; 0000 0138         if(lights_on && !engine)
_0x45:
	SBRS R2,1
	RJMP _0x49
	SBRS R2,0
	RJMP _0x4A
_0x49:
	RJMP _0x48
_0x4A:
; 0000 0139             alarm(3);
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _alarm
; 0000 013A 
; 0000 013B         //low voltage after 1min of engine run -> ALARM!
; 0000 013C         if(!lights_on && !engine)
_0x48:
	SBRC R2,1
	RJMP _0x4C
	SBRS R2,0
	RJMP _0x4D
_0x4C:
	RJMP _0x4B
_0x4D:
; 0000 013D             alarm(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _alarm
; 0000 013E         }
_0x4B:
_0x44:
; 0000 013F     };
	RJMP _0x40
; 0000 0140 }
_0x4E:
	RJMP _0x4E

	.DSEG
_measured_voltage:
	.BYTE 0x100

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	IN   R30,0x35
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	IN   R30,0x3B
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	LDI  R26,LOW(_measured_voltage)
	LDI  R27,HIGH(_measured_voltage)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
